<?php
include '././include/func.php';
class System{


    public static function GetMacAddress(){
        $cOS = Func::getOS();
        $cMac = "";
        $aCfg = new aCfg();

        switch ($cOS) {
            case "WINNT":
                $cMac = self::GetMacAddress_Windows();
            break;
            case "Linux":
                $cMac = self::GetMacAddress_Ubuntu();
            break;
            case "Darwin":
                break;
        }
        $aCfg->set("MAC",$cMac);
        return $cMac;
    }

    private static function GetMacAddress_Windows()
    {
        #cek mac address        
        $output = Func::exec("wmic nic where (AdapterTypeId=0 AND netConnectionStatus=2) get MACAddress",false);
        $mac = "00:00:00:00";
        // var_dump($output);
        if (!empty($output) && count($output) >= 2) {
            if ($output[1] != "") {
                $mac = $output[1];
            }
        }
        return $mac;
    }

    private static function GetMacAddress_Ubuntu(){
        return Func::exec("cat /sys/class/net/$(ip route show default | awk '/default/ {print $5}')/address",false)[0];
    }

    public static function GetIPAddress(){
        $cOS = Func::getOS();

        switch ($cOS) {
            case "WINNT":
                return self::GetIPAddress_Windows();
            case "Linux":
                return self::GetIPAddress_Ubuntu()[0];
            case "Darwin":
                break;
        }
    }

    private static function GetIPAddress_Windows(){
        #cek ip pada wifi
        $output = Func::exec("for /f \"tokens=3 delims=: \" %i  in ('netsh interface ip show config name^=\"Wi-Fi\" ^| findstr \"IP Address\"') do echo %i",false);
        $valid = true;
        if (empty($output)) {
            $valid = false;
        } else if (count($output) >= 3) {
            $valid = false;
            if ($output[2] != "") $valid = true;
        }

        $ip = "0.0.0.0";
        if ($valid) {
            $ip = $output[2];
        } else {
            #cek ip pada jaringan selain lan, ini pada ethernet
            $output = Func::exec("for /f \"tokens=3 delims=: \" %i  in ('netsh interface ip show config name^=\"Ethernet\" ^| findstr \"IP Address\"') do echo %i",false);
            if (!empty($output) && count($output) >= 3) {
                if ($output[2] != "") $ip = $output[2];
            }
        }
        return  $ip;
    }

    private static function GetIPAddress_Ubuntu(){
        $output = Func::exec('hostname -I');
        return $output;
    }


    public static function GetDefaultGateway(){
        $cOS = Func::getOS();
        Func::writeLog("Getting defauklt gateway");

        switch ($cOS) {
            case "WINNT":
                return self::GetDefaultGateway_Windows();
            case "Linux":
                break;
            case "Darwin":
                break;
        }
    }

    private static function GetDefaultGateway_Windows(){
        //$output = Func::exec("for /f \"tokens=1-2 delims=:\" %a in ('ipconfig^|find \"Default\"') do echo %b",false);            
        $cCommand = '"' . $_SERVER['DOCUMENT_ROOT'] . '\include\lib\gateway.bat"';
        $output = Func::exec($cCommand);
        return $output[count($output)-1];
    }

    public static function gw(){
        $cCommand = '"' . $_SERVER['DOCUMENT_ROOT'] . '\include\lib\gateway.bat"';
        $output = Func::exec($cCommand);
        func::writeLog("gateway req ". $cCommand);
        func::writeLog("gateway res ". json_encode($output));
        return json_encode($output);
    }

    

}