<?php
 
require_once 'func.php'; 

  class MicroService{
    #url
    public static $url_main = "http://myassist.id:2757/assist-serviceadmin/";

    #vpn api
    public static $editvpnstatus = 'vpnauth/editvpnstatus';
    public static $cekvpn = 'vpnauth/cekvpn';
    public static $disconnectvpn = 'vpnauth/disconnectvpn';


    public static function CekResponse($cTRXID,$cURL = ''){
      $cURL = $cURL == '' ? self::$url_main . '/cek/cekresponse?TRXID='.$cTRXID : $cURL; 
      
      $ch = curl_init();  

      curl_setopt($ch,CURLOPT_URL,$cURL);
      curl_setopt($ch,CURLOPT_RETURNTRANSFER,true);

      $cResponse = curl_exec($ch);
    
      curl_close($ch);   
      
      return $cResponse;
    }
    
    public static function Exec($cDestination,$vaBody,$cURL=''){
      // $cURL = $cURL == '' ?  self::$url_main . '/admin/admin' : $cURL; 
      $cURL = $cURL == '' ? "http://myassist.id:2757/assist-microservice_myassist/".$cDestination : $cURL;
      // $cURL = $cURL == '' ?  self::$url_main . '/admin/admin' : $cURL; 
      # generate request
      $vaParam = array();
      $vaParam['TRXID'] = self::GenTRXID();
      $vaParam['SecureID'] = '$2y$10$lc1n7XIpPPscyHgozhydwelWWVivNItYS6DQaBfuuMlg/Z9mWg0Gy';
      $vaParam['IPAddress']= self::GetIPAddress();
      $vaParam['Destination'] = $cDestination;
      $vaParam['Body'] = json_encode($vaBody);
      $vaParam['Status'] = 0;
      $vaParam['UserName'] = "VPN";
      $vaParam['DateTime'] = Func::SNow();
      $ch = curl_init($cURL);
      curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);       
      // curl_setopt($ch, CURLOPT_TIMEOUT, 100);  
      curl_setopt($ch, CURLOPT_CONNECTTIMEOUT, 0); 
      curl_setopt($ch, CURLOPT_TIMEOUT, 0); //timeout in seconds
      curl_setopt($ch, CURLOPT_POSTFIELDS, $vaParam);
      curl_setopt($ch, CURLOPT_FAILONERROR, true);
      $cResponse = curl_exec($ch);
      if ($cResponse === false) 
      $cResponse = curl_error($ch);
    
      curl_close($ch);
      return $cResponse; 
    }  
  
    private static function GenTRXID(): string{
      $cRand = bin2hex(random_bytes(4));
      return session_id() . $cRand . time();
    }
    
    private static function GetIPAddress() {
      $ipaddress = '';
      if (getenv('HTTP_CLIENT_IP'))
          $ipaddress = getenv('HTTP_CLIENT_IP');
      else if(getenv('HTTP_X_FORWARDED_FOR'))
          $ipaddress = getenv('HTTP_X_FORWARDED_FOR');
      else if(getenv('HTTP_X_FORWARDED'))
          $ipaddress = getenv('HTTP_X_FORWARDED');
      else if(getenv('HTTP_FORWARDED_FOR'))
          $ipaddress = getenv('HTTP_FORWARDED_FOR');
      else if(getenv('HTTP_FORWARDED'))
         $ipaddress = getenv('HTTP_FORWARDED');
      else if(getenv('REMOTE_ADDR'))
          $ipaddress = getenv('REMOTE_ADDR');
      else
          $ipaddress = 'UNKNOWN';
      return $ipaddress;
    }
    public static function FetchResponse($cResponse){
      # memecah response
      $vaResponse = json_decode($cResponse,1);
      # memecah response     
      if(isset($vaResponse[1])){
        return $vaResponse;  
      }else{
        $vaResponse = isset($vaResponse[0]) ?  $vaResponse[0] : $vaResponse; 
      }
      
      return $vaResponse;  
    }
    private static function Cek($cTRXID){
      $cResponse = self::CekResponse($cTRXID) ;    
      //return $cResponse;
      return self::ProsesData($cResponse);
    }

    private static function ProsesData($cResponse){
      # memecah response
      $vaResponse = self::FetchResponse($cResponse);
      
      # jika response tidak bisa dipecah, kita anggap error
      if(empty($vaResponse)){
      
        # proses selesai
        return $cResponse;
      }

      # jika status 3
      if($vaResponse['Status']==3 ){
        return "Terjadi kesalahan saat meningirim data, coba lagi";
      }
    
      # jika status 1 berarti proses
      if($vaResponse['Status']==1){
        
      
        return self::Cek($vaResponse['TRXID']);
      }else
        return $vaResponse;
    }

    public static function ExecAndLoop($cDestination,$vaBody,$cURL=''){
      $cResponse = MicroService::Exec($cDestination,$vaBody,$cURL);
      return self::ProsesData($cResponse); 
    }
   
  }
